#ifndef EFL_GENERATED_EVAS_SMART_CLIPPED_HH
#define EFL_GENERATED_EVAS_SMART_CLIPPED_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_smart_clipped.eo.h"
}

#include "evas_object_smart.eo.hh"

namespace evas {

struct smart_clipped;

}

namespace eo_cxx {

namespace evas {

struct smart_clipped
{

   static Eo_Class const* _eo_class()
   {
      return(EVAS_SMART_CLIPPED_CLASS);
   }

   operator ::evas::smart_clipped() const;
   operator ::evas::smart_clipped&();
   operator ::evas::smart_clipped const&() const;

   template <typename D>
   struct address_of
   {
      operator ::evas::smart_clipped*() const { return static_cast<::evas::smart_clipped*>(static_cast<D const*>(this)->p); }
      operator ::evas::smart_clipped const*() const { return static_cast<::evas::smart_clipped const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::evas::smart_clipped const*() const { return static_cast<::evas::smart_clipped const*>(static_cast<D const*>(this)->p); }
   };

private:
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

}

namespace evas {

struct smart_clipped
      : ::efl::eo::concrete
      , ::eo_cxx::eo::base
      , ::eo_cxx::evas::common_interface
      , ::eo_cxx::evas::object
      , ::eo_cxx::evas::object_smart
      , ::eo_cxx::evas::signal_interface
{
   smart_clipped(::efl::eo::parent_type _p = (::efl::eo::parent = nullptr))
      : smart_clipped(_ctors_call(_p))
   {}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit smart_clipped(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit smart_clipped(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   smart_clipped(smart_clipped const& other)
      : smart_clipped(eo_ref(other._eo_ptr()))
   {}

   ~smart_clipped() {}


   static Eo_Class const* _eo_class()
   {
      return(EVAS_SMART_CLIPPED_CLASS);
   }

   struct address_of
      : ::eo_cxx::evas::smart_clipped::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::eo_cxx::evas::common_interface::address_of<address_of>
      , ::eo_cxx::evas::object::address_of<address_of>
      , ::eo_cxx::evas::object_smart::address_of<address_of>
      , ::eo_cxx::evas::signal_interface::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::evas::smart_clipped* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::evas::smart_clipped::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::eo_cxx::evas::common_interface::address_const_of<address_const_of>
      , ::eo_cxx::evas::object::address_const_of<address_const_of>
      , ::eo_cxx::evas::object_smart::address_const_of<address_const_of>
      , ::eo_cxx::evas::signal_interface::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::evas::smart_clipped const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

private:
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(EVAS_SMART_CLIPPED_CLASS, _p._eo_raw, );

      return _ret_eo;
   }

      Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::evas::smart_clipped) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::evas::smart_clipped>::value, "");

}

inline ::eo_cxx::evas::smart_clipped::operator ::evas::smart_clipped() const
{
   return *static_cast<::evas::smart_clipped const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::evas::smart_clipped::operator ::evas::smart_clipped&()
{
   return *static_cast<::evas::smart_clipped*>(static_cast<void*>(this));
}

inline ::eo_cxx::evas::smart_clipped::operator ::evas::smart_clipped const&() const
{
   return *static_cast<::evas::smart_clipped const*>(static_cast<void const*>(this));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas::smart_clipped >
{
   template <typename T>
   struct type
         : virtual operations< ::evas::object_smart >::template type<T>
   {
   };
};


template<>
struct operation_description_class_size< ::evas::smart_clipped >
{
   static const int value = 0 + operation_description_class_size<::evas::object_smart >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::evas::smart_clipped>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::object_smart>(), &ops[0]);
   return 0;
}
inline void
call_constructor(::efl::eo::detail::tag< ::evas::smart_clipped >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               ::efl::eo::detail::args_class<::evas::smart_clipped, ::std::tuple<::efl::eo::parent_type> > const& args)
{
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

inline Eo_Class const* get_eo_class(tag<::evas::smart_clipped>)
{
   return (EVAS_SMART_CLIPPED_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_SMART_CLIPPED_HH

